;##################################################################
; About Box Demo
;##################################################################

#include "AboutBox.Inc"

IDD_DLG1	equ		1000
ABOUTCOLOR	equ		00FF8080h
ABOUTIMEOUT	equ		10000 ; Milliseconds

/*
Hyperlink constants
*/
HLM_SETTYPE				equ		WM_USER+200 ; lParam = HLINK_URL/HLINK_EMAIL wndxtra 0
HLM_SETHOTCOLOR			equ		WM_USER+201 ; lParam = Hot color wndxtra 4
HLM_SETTEXTCOLOR		equ		WM_USER+202 ; lParam = Normal text color wndxtra 8
HLM_SETSUBJECT			equ		WM_USER+203 ; lParam = Email subject line wndxtra 24
HLM_SETBODY				equ		WM_USER+204 ; lParam = Email body wndxtra 28
HLM_SETUNDERLINE		equ		WM_USER+205 ; lParam = Underline link TRUE/FALSE wndxtra 32
HLM_SETLINK				equ		WM_USER+206	; lParam = Hyperlink URL wndxtra 36
HLINK_URL				equ		0
HLINK_EMAIL				equ		1

DATA SECTION
	hInstance		DD	?
	hFont10			DD	?
	hIcon			DD	?
	
	Arial_Black_10 LOGFONT <-13,0,0,0,400,0,0,0,0,3,2,1,34,"Arial Black">

	szVersion		DB	"About Box Version 1.02",0

	EmailDisplay	DB	"Email me",0
	Email			DB	"donkey@visualassembler.com",0

	WebSiteDisplay	DB	"Visit my website",0
	WebSite			DB	"http://donkey.visualassembler.com",0

	AboutText		DB	"About Box:",13,10,13,10
					DB	"Copyright  2003-2005 Edgar Hansen (Donkey)",13,10,13,10
					DB	"This program is free for any use as long as "
					DB	"the source of the program is not misrepresented. "
					DB	"It can be distributed with any package including "
					DB	"commercial software without requiring permission ",13,10,13,10
					DB	"This program is distributed as freeware and  "
					DB	"WITHOUT ANY WARRANTY including the implied "
					DB	"warranty of MERCHANTABILITY or FITNESS FOR "
					DB	"A PARTICULAR PURPOSE",13,10,13,10
					DB	"If you feel the need to ask for permission "
					DB	"you may do so, but if I don't have time to "
					DB	"respond you can take that as a YES, USE IT "
					DB	"(even the GPL guys)",13,10,13,10
					DB	"As is normal with my code you do not have to "
					DB	"specify that it came from me but a mention in "
					DB	"the about box would be nice",0

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitHyperLinkClass
	invoke LoadIcon,[hInstance],12000
	mov [hIcon],eax
	invoke CreateFontIndirect,offset Arial_Black_10
	mov [hFont10],eax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke DeleteObject, [hFont10]
	invoke DestroyIcon, [hIcon]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >.WMCOMMAND

		jmp >.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCLOSE
		cmp W[wParam], 1001
		jne >.EXIT
			invoke DialogBoxParam,[hInstance],104,[hwnd],OFFSET AboutProc,OFFSET AboutText
		jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

AboutProc FRAME hWin,uMsg,wParam,lParam
	uses ebx, esi, edi
	LOCAL	hEdit	:D

	cmp D[uMsg], WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke SetDlgItemText,[hWin],1001,[lParam]
		invoke SetDlgItemText,[hWin],1002,OFFSET szVersion
		invoke SendDlgItemMessage,[hWin],1002,WM_SETFONT,[hFont10],TRUE
		invoke SetTimer,[hWin],1,ABOUTIMEOUT/100,NULL
		invoke SetTimer,[hWin],2,ABOUTIMEOUT,NULL
		invoke CreateSolidBrush,ABOUTCOLOR
		invoke SetWindowLong,[hWin],GWL_USERDATA,eax

		invoke SendDlgItemMessage,[hWin],1004,STM_SETIMAGE,IMAGE_ICON,[hIcon]
		invoke SendDlgItemMessage,[hWin],1005,PBM_SETPOS,100,0
		invoke SendDlgItemMessage,[hWin],1005,PBM_SETSTEP,1,0
		invoke SendDlgItemMessage,[hWin],1005,PBM_SETBKCOLOR,0,ABOUTCOLOR

;		invoke CreateFontIndirect,OFFSET WebFont
;		mov hWebFont,eax

		invoke SendDlgItemMessage,[hWin],1006,WM_SETTEXT,0,offset EmailDisplay
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETLINK,0,OFFSET Email
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETHOTCOLOR,0,0FF0000h
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETTEXTCOLOR,0,0
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETTYPE,0,HLINK_EMAIL
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETSUBJECT,0,OFFSET szVersion
		invoke SendDlgItemMessage,[hWin],1006,HLM_SETUNDERLINE,0,TRUE
;		invoke SendDlgItemMessage,[hWin],1006,WM_SETFONT,hWebFont,TRUE

		invoke SendDlgItemMessage,[hWin],1007,WM_SETTEXT,0,offset WebSiteDisplay
		invoke SendDlgItemMessage,[hWin],1007,HLM_SETLINK,0,OFFSET WebSite
		invoke SendDlgItemMessage,[hWin],1007,HLM_SETHOTCOLOR,0,0FF0000h
		invoke SendDlgItemMessage,[hWin],1007,HLM_SETTEXTCOLOR,0,0
		invoke SendDlgItemMessage,[hWin],1007,HLM_SETTYPE,0,HLINK_URL
		invoke SendDlgItemMessage,[hWin],1007,HLM_SETUNDERLINE,0,TRUE
;		invoke SendDlgItemMessage,[hWin],1007,WM_SETFONT,hWebFont,TRUE

		invoke GetDlgItem,[hWin],1001
		mov [hEdit],eax
		invoke InitializeFlatSB,[hEdit]
		invoke FlatSB_SetScrollProp,[hEdit],WSB_PROP_VBKGCOLOR,ABOUTCOLOR,TRUE
		invoke FlatSB_SetScrollProp,[hEdit],WSB_PROP_HSTYLE,FSB_FLAT_MODE,TRUE
		ret

	.WM_COMMAND
	cmp D[uMsg], WM_COMMAND
	jne >>.WM_CTLCOLORDLG
		cmp D[wParam], 1008
		jne >.CMDEXIT
			invoke SendDlgItemMessage,[hWin],1008,BM_GETCHECK,0,0
			cmp eax, BST_CHECKED
			jne >
				invoke KillTimer,[hWin],1
				invoke KillTimer,[hWin],2
				ret
			:
				invoke SendDlgItemMessage,[hWin],1005,PBM_GETPOS,0,0
				mov cx,100
				mul cx
				invoke SetTimer,[hWin],2,eax,NULL
				invoke SetTimer,[hWin],1,ABOUTIMEOUT/100,NULL
				ret
		.CMDEXIT
		cmp W[wParam], 1001
		je >>.EXIT
			invoke PostMessage,[hWin],WM_CLOSE,0,0
			jmp >>.EXIT

	.WM_CTLCOLORDLG
	cmp D[uMsg], WM_CTLCOLORDLG
	jne >>.WM_CTLCOLORSTATIC
		invoke SetTextColor,[wParam],0
		invoke SetBkColor,[wParam],ABOUTCOLOR
		invoke GetWindowLong,[hWin],GWL_USERDATA
		ret

	.WM_CTLCOLORSTATIC
	cmp D[uMsg], WM_CTLCOLORSTATIC
	jne >.WM_CTLCOLOREDIT
		invoke SetTextColor,[wParam],0
		invoke SetBkColor,[wParam],ABOUTCOLOR
		invoke GetWindowLong,[hWin],GWL_USERDATA
		ret

	.WM_CTLCOLOREDIT
	cmp D[uMsg], WM_CTLCOLOREDIT
	jne >.WM_TIMER
		invoke SetTextColor,[wParam],0
		invoke SetBkColor,[wParam],ABOUTCOLOR
		invoke GetWindowLong,[hWin],GWL_USERDATA
		ret

	.WM_TIMER
	cmp D[uMsg], WM_TIMER
	jne >.WM_CLOSE
		cmp D[wParam], 1
		jne >
			invoke SendDlgItemMessage,[hWin],1005,PBM_GETPOS,0,0
			dec eax
			invoke SendDlgItemMessage,[hWin],1005,PBM_SETPOS,eax,0
			jmp >>.EXIT
		:
			invoke SendDlgItemMessage,[hWin],1001,WM_CANCELMODE,0,0
			invoke PostMessage,[hWin],WM_CLOSE,0,0
			jmp >>.EXIT

	.WM_CLOSE
	cmp D[uMsg], WM_CLOSE
	jne >.DEFPROC
		invoke KillTimer,[hWin],1
		invoke KillTimer,[hWin],2
		invoke GetWindowLong,[hWin],GWL_USERDATA
		invoke DeleteObject,eax
;		invoke DeleteObject,hWebFont
		invoke EndDialog,[hWin],NULL

	.DEFPROC
		sub eax,eax
		ret

	.EXIT
		sub eax,eax
		inc eax
		ret

ENDF

/*
Hyperlink code
*/

_Hyperlink FRAME hlc_hWin,hlc_uMsg,hlc_wParam,hlc_lParam
	LOCAL hlc_tme				:TRACKMOUSEEVENT
	LOCAL hlc_ps				:PAINTSTRUCT
	LOCAL hlc_hdc				:D
	LOCAL hlc_strlen			:D
	LOCAL hlc_prc				:RECT
	LOCAL hlc_color				:D
	LOCAL hlc_pt				:POINT
	LOCAL hlc_text[2048]		:B
	LOCAL hlc_pSubject			:D

	cmp D[hlc_uMsg],WM_SETTEXT
	jne >>.WM_CREATE
		; Get the border size
		invoke GetWindowRect,[hlc_hWin],ADDR hlc_prc
		mov eax,[hlc_prc.right]
		sub eax,[hlc_prc.left]
		push eax
		mov eax,[hlc_prc.bottom]
		sub eax,[hlc_prc.top]
		push eax
		invoke GetClientRect,[hlc_hWin],ADDR hlc_prc
		pop eax
		sub eax,[hlc_prc.bottom]
		pop ecx
		push eax
		sub ecx,[hlc_prc.right]
		push ecx

		invoke GetDC,[hlc_hWin]
		mov [hlc_hdc],eax

		invoke GetWindowLong,[hlc_hWin],20
		or eax,eax
		jnz >
			invoke GetStockObject,SYSTEM_FONT
		:
		invoke SelectObject,[hlc_hdc],eax
		invoke lstrlen,[hlc_lParam]
		invoke DrawText,[hlc_hdc],[hlc_lParam],eax,ADDR hlc_prc,DT_CALCRECT
		pop ecx
		add ecx,[hlc_prc.right]
		sub ecx,[hlc_prc.left]

		pop eax
		add eax,[hlc_prc.bottom]
		sub eax,[hlc_prc.top]
		invoke SetWindowPos,[hlc_hWin],HWND_TOP,0,0,ecx,eax,SWP_NOMOVE or SWP_NOZORDER
		invoke ReleaseDC,[hlc_hWin],[hlc_hdc]
		jmp >>.DONE

	.WM_CREATE
	cmp D[hlc_uMsg],WM_CREATE
	jne >>.HLM_SETTYPE
		invoke GlobalAlloc,GPTR,4192
		invoke SetWindowLong,[hlc_hWin],12,eax
		jmp >>.DONE

	.HLM_SETTYPE
	cmp D[hlc_uMsg],HLM_SETTYPE
	jne >.HLM_SETUNDERLINE
		invoke SetWindowLong,[hlc_hWin],0,[hlc_lParam]
		ret

	.HLM_SETUNDERLINE
	cmp D[hlc_uMsg],HLM_SETUNDERLINE
	jne >.HLM_SETHOTCOLOR
		invoke SetWindowLong,[hlc_hWin],32,[hlc_lParam]
		ret

	.HLM_SETHOTCOLOR
	cmp D[hlc_uMsg],HLM_SETHOTCOLOR
	jne >>.HLM_SETTEXTCOLOR
		invoke SetWindowLong,[hlc_hWin],4,[hlc_lParam]
		; set the current color if necessary
		invoke GetCursorPos,ADDR hlc_pt
		invoke GetParent,[hlc_hWin]
		push eax
		mov ecx,eax
		invoke ScreenToClient,ecx,ADDR hlc_pt
		pop ecx
		invoke ChildWindowFromPoint,ecx,[hlc_pt.x],[hlc_pt.y]
		cmp eax,[hlc_hWin]
		jne >
			invoke SetWindowLong,[hlc_hWin],16,[hlc_lParam]
			mov D[hlc_tme.cbSize],SIZEOF TRACKMOUSEEVENT
			mov D[hlc_tme.dwFlags],TME_LEAVE
			mov eax,[hlc_hWin]
			mov [hlc_tme.hwndTrack],eax
			mov D[hlc_tme.dwHoverTime],HOVER_DEFAULT
			invoke _TrackMouseEvent,ADDR hlc_tme
		:
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		invoke UpdateWindow,[hlc_hWin]
		ret

	.HLM_SETTEXTCOLOR
	cmp D[hlc_uMsg],HLM_SETTEXTCOLOR
	jne >>.HLM_SETSUBJECT
		invoke SetWindowLong,[hlc_hWin],8,[hlc_lParam]
		; set the current color if necessary
		invoke GetCursorPos,ADDR hlc_pt
		invoke GetParent,[hlc_hWin]
		push eax
		mov ecx,eax
		invoke ScreenToClient,ecx,ADDR hlc_pt
		pop ecx
		invoke ChildWindowFromPoint,ecx,[hlc_pt.x],[hlc_pt.y]
		cmp eax,[hlc_hWin]
		je >
			invoke SetWindowLong,[hlc_hWin],16,[hlc_lParam]
		:
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		invoke UpdateWindow,[hlc_hWin]
		ret

	.HLM_SETSUBJECT
	cmp D[hlc_uMsg],HLM_SETSUBJECT
	jne >>.HLM_SETLINK
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],24
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],24,[hlc_pSubject]
		ret

	.HLM_SETLINK
	cmp D[hlc_uMsg],HLM_SETLINK
	jne >>.HLM_SETBODY
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],36
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],36,[hlc_pSubject]
		ret

	.HLM_SETBODY
	cmp D[hlc_uMsg],HLM_SETBODY
	jne >>.WM_SETFONT
		invoke lstrlen,[hlc_lParam]
		inc eax
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],28
		mov [hlc_pSubject],eax
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GlobalAlloc,GPTR,[hlc_strlen]
		mov [hlc_pSubject],eax
		cmp D[hlc_strlen],1024
		jl >
			mov eax,[hlc_lParam]
			add eax,1023
			mov B[eax],0
		:
		invoke lstrcpy,[hlc_pSubject],[hlc_lParam]
		invoke SetWindowLong,[hlc_hWin],28,[hlc_pSubject]
		ret

	.WM_SETFONT
	cmp D[hlc_uMsg],WM_SETFONT
	jne >.WM_LBUTTONDOWN
		; The def window proc does not do fonts so it has to be done manually
		invoke SetWindowLong,[hlc_hWin],20,[hlc_wParam]
		invoke GetWindowText,[hlc_hWin],ADDR hlc_text,256
		invoke SetWindowText,[hlc_hWin],ADDR hlc_text
		mov eax,[hlc_lParam]
		or eax,eax
		jz >
			invoke InvalidateRect,[hlc_hWin],NULL,TRUE
			invoke UpdateWindow,[hlc_hWin]
		:
		ret

	.WM_LBUTTONDOWN
	cmp D[hlc_uMsg],WM_LBUTTONDOWN
	jne >>.WM_MOUSEMOVE
		invoke GetWindowLong,[hlc_hWin],12
		mov [hlc_pSubject],eax

		invoke GetWindowLong,[hlc_hWin],0
		cmp eax,HLINK_URL
		jne >B1
			invoke GetWindowLong,[hlc_hWin],36
			mov [hlc_pSubject],eax
			invoke lstrlen,eax
			jnz >
				invoke GetWindowText,[hlc_hWin],[hlc_pSubject],256
			:
		B1:
		cmp eax,HLINK_EMAIL
		jne >>B2
			invoke GetWindowLong,[hlc_hWin],36
			mov ebx,eax
			invoke lstrlen,ebx
			jnz >
				xor ebx,ebx
			:
			invoke lstrcpy,[hlc_pSubject],OFFSET hlc_szMailTo
			mov eax,[hlc_pSubject]
			add eax,7
			or ebx,ebx
			jz >
				invoke lstrcpy,eax,ebx
				jmp >B0
			:
				invoke GetWindowText,[hlc_hWin],eax,240
			B0:
			invoke GetWindowLong,[hlc_hWin],24
			or eax,eax
			jz >>B2
				push eax
				invoke lstrcat,[hlc_pSubject],OFFSET hlc_szSubject
				pop eax
				mov D[hlc_strlen],2048
				invoke lstrcat,[hlc_pSubject],eax
				invoke GetWindowLong,[hlc_hWin],28
				or eax,eax
				jz >B2
				push eax
				invoke lstrcat,[hlc_pSubject],OFFSET hlc_szBody
				pop eax
				invoke lstrcat,[hlc_pSubject],eax
		B2:
		invoke FormatURL,[hlc_pSubject],OFFSET hlc_text,TRUE
		invoke ShellExecute, [hlc_hWin], OFFSET hlc_szOpen,OFFSET hlc_text, 0, 0, SW_SHOWNORMAL
		jmp >>.DONE

	.WM_MOUSEMOVE
	cmp D[hlc_uMsg],WM_MOUSEMOVE
	jne >>.WM_MOUSELEAVE
		; The first mouse move message changes the color
		invoke GetWindowLong,[hlc_hWin],4
		push eax
		invoke SetWindowLong,[hlc_hWin],16,eax
		pop ecx
		cmp eax,ecx
		je >>.DONE
			mov D[hlc_tme.cbSize],SIZEOF TRACKMOUSEEVENT
			mov D[hlc_tme.dwFlags],TME_LEAVE
			mov eax,[hlc_hWin]
			mov [hlc_tme.hwndTrack],eax
			mov D[hlc_tme.dwHoverTime],HOVER_DEFAULT
			invoke _TrackMouseEvent,ADDR hlc_tme
			invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		jmp >>.DONE

	.WM_MOUSELEAVE
	cmp D[hlc_uMsg],WM_MOUSELEAVE
	jne >.WM_PAINT
		invoke GetWindowLong,[hlc_hWin],8
		invoke SetWindowLong,[hlc_hWin],16,eax
		invoke InvalidateRect,[hlc_hWin],NULL,TRUE
		ret

	.WM_PAINT
	cmp D[hlc_uMsg],WM_PAINT
	jne >>.WM_DESTROY
		invoke GetWindowText,[hlc_hWin],ADDR hlc_text,256
		mov [hlc_strlen],eax
		invoke GetWindowLong,[hlc_hWin],16
		mov [hlc_color],eax
		invoke BeginPaint,[hlc_hWin],ADDR hlc_ps
			mov [hlc_hdc],eax
			invoke GetWindowLong,[hlc_hWin],20 ;Font
			invoke SelectObject,[hlc_hdc],eax
			invoke SetTextColor,[hlc_hdc],[hlc_color]
			invoke SetBkMode,[hlc_hdc],TRANSPARENT
			invoke TextOut,[hlc_hdc],0,0,ADDR hlc_text,[hlc_strlen]

			invoke GetWindowLong,[hlc_hWin],32 ; Underline
			or eax,eax
			jz >>
				; a line is drawn
				invoke CreatePen,PS_SOLID,1,[hlc_color]
				invoke SelectObject,[hlc_hdc],eax
				push eax
				invoke GetClientRect,[hlc_hWin],ADDR hlc_prc
				dec D[hlc_prc.bottom]
				invoke MoveToEx,[hlc_hdc],0,[hlc_prc.bottom],NULL
				invoke LineTo,[hlc_hdc],[hlc_prc.right],[hlc_prc.bottom]
				pop eax
				invoke SelectObject,[hlc_hdc],eax
				invoke DeleteObject,eax
			:

		invoke EndPaint,[hlc_hWin],ADDR hlc_ps
		ret

	.WM_DESTROY
	cmp D[hlc_uMsg],WM_DESTROY
	jne >.DONE
		invoke GetWindowLong,[hlc_hWin],12
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],24
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],28
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:
		invoke GetWindowLong,[hlc_hWin],36
		or eax,eax
		jz >
			invoke GlobalFree,eax
		:

	.DONE
	invoke DefWindowProc,[hlc_hWin],[hlc_uMsg],[hlc_wParam],[hlc_lParam]
	ret

	hlc_szMailTo: 	db		"mailto:",0
	hlc_szSubject:	db		"?subject=",0
	hlc_szBody:		db		"&body=",0
	hlc_szOpen:		db		"open",0

ENDF

InitHyperLinkClass FRAME
	LOCAL hlc_wcx			:WNDCLASSEX

	mov D[hlc_wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[hlc_wcx.style], CS_HREDRAW + CS_VREDRAW
	invoke GetModuleHandle, 0
	mov D[hlc_wcx.hInstance],eax
	mov D[hlc_wcx.lpszClassName],OFFSET UDC_HyperClass
	mov D[hlc_wcx.cbClsExtra],0
	mov D[hlc_wcx.cbWndExtra],40
	mov D[hlc_wcx.lpfnWndProc],OFFSET _Hyperlink
	mov D[hlc_wcx.hIcon],NULL
	mov D[hlc_wcx.hIconSm],NULL
	invoke GetStockObject,NULL_BRUSH
	mov D[hlc_wcx.hbrBackground],eax
	mov D[hlc_wcx.lpszMenuName],NULL

	invoke LoadCursor,NULL,IDC_HAND
	mov [hlc_wcx.hCursor],eax

	invoke RegisterClassEx,ADDR hlc_wcx

	ret

	UDC_HyperClass:	db		"UDC_HyperLink",0
ENDF

FormatURL FRAME pString,pOutString,DoPercent
	uses ebx,esi,edi
	mov edi,[pOutString]
	mov esi,[pString]
	mov ebx,[DoPercent]

	L0:
	mov al,[esi]
	cmp al,0
	je >>.DONE

	; Chars
	cmp al,"a"
	jb >
	cmp al,"z"
	jbe >.NORMAL
	:
	cmp al,"A"
	jb >
	cmp al,"Z"
	jbe >.NORMAL
	:
	cmp al,"0"
	jb >
	cmp al,"9"
	jbe >.NORMAL
	:

	; Allowed
	cmp al,"-"
	je >.NORMAL
	cmp al,"_"
	je >.NORMAL
	cmp al,"."
	je >.NORMAL
	cmp al,"!"
	je >.NORMAL
	cmp al,"-"
	je >.NORMAL
	cmp al,"*"
	je >.NORMAL
	cmp al,27h
	je >.NORMAL
	cmp al,"("
	je >.NORMAL
	cmp al,")"
	je >.NORMAL

	; Reserved
	cmp al,";"
	je >.NORMAL
	cmp al,"/"
	je >.NORMAL
	cmp al,"?"
	je >.NORMAL
	cmp al,":"
	je >.NORMAL
	cmp al,"@"
	je >.NORMAL
	cmp al,"&"
	je >.NORMAL
	cmp al,"="
	je >.NORMAL
	cmp al,"+"
	je >.NORMAL
	cmp al,"$"
	je >.NORMAL
	cmp al,","
	je >.NORMAL

	.REPLACE
	cmp al,"%"
	jne >
	or ebx,ebx
	jz >.NORMAL
	:
	movzx edx,al
	invoke wsprintf,edi,"%%%0.2X",edx
	add esp,12
	add edi,3
	inc esi
	jmp <<L0

	.NORMAL
	movsb
	jmp <<L0

	.DONE
	mov B[edi],0
	ret
ENDF
